



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>判断一个字符串是不是一个合法的IP地址</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">判断一个字符串是不是一个合法的IP地址</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 08:44:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>最近在笔试的时候遇到碰一道算法题，</p>
<p>要求判断一个字符串是不是合法的ip地址。</p>
<p>将我的思路发出来分享一下，不一定正确，也不一定是最优的方法。希望能分享一些交流</p>
<p>要求用java或者c来实现，我的java代码：</p>
<div>
<pre class="prettyprint linenums"> public class Test_ip {<br />
     //程序入口<br />
     public static void main(String[] args) {<br />
         Solution s = new Solution();    // 业务逻辑放在Solution类里面<br />
         //String test_str = "12.34.56.67";<br />
         String test_str = "256.34.56.67";    // 待解决的字符串<br />
         boolean res = s.test_ip(test_str);    //调用判断方法<br />
         System.out.println(res);    //输出结果<br />
     }<br />
 }

 class Solution{<br />
     /**<br />
      * 判断一个字符串是否是一个合法的ip地址：<br />
      *    1 首先检查字符串的长度 最短应该是0.0.0.0 7位 最长 000.000.000.000 15位<br />
      *    2 尝试按.符号进行拆分     拆分结果应该是4段<br />
      *    3 查看拆分到的每一个子字符串，应该都是纯数字<br />
      *    4 对拆分结果转成整数 判断 应该是0到255之间的整数<br />
      *    5 经过各种磨砺之后 挺过来了！！！返回true<br />
      */<br />
     public boolean test_ip(String str){<br />
         // 1 首先检查字符串的长度 最短应该是0.0.0.0 7位 最长 000.000.000.000 15位<br />
         if(str.length()&lt;7 || str.length() &gt;15) return false;    // 如果长度不符合条件 返回false

         // 2 尝试按.符号进行拆分     拆分结果应该是4段<br />
         String[] arr = str.split("\\.");<br />
         if( arr.length != 4 )    return false;    //如果拆分结果不是4个字串 返回false

         // 3 查看拆分到的每一个子字符串，应该都是纯数字<br />
         for(int i = 0 ; i &lt;4 ; i++ ){<br />
             for(int j = 0; j&lt;arr[i].length();j++){<br />
                 char temp = arr[i].charAt(j);<br />
                 if(!( temp&gt;'0' &amp;&amp; temp&lt; '9' ) ) return false;    //如果某个字符不是数字就返回false<br />
             }<br />
         }

         // 4 对拆分结果转成整数 判断 应该是0到255之间的整数<br />
         for(int i = 0 ; i&lt;4;i++){<br />
             int temp = Integer.parseInt( arr[i] );<br />
             if( temp&lt;0 || temp &gt;255)    return false;    //如果某个数字不是0到255之间的数 就返回false<br />
         }

         // 5 经过各种磨砺之后 挺过来了！！！返回true<br />
         return true;<br />
     }<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4d65nq.html">提高 ASP&period;NET Web 应用性能的 24 种方法和技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnl0v39.html">最小生成树POJ3522 Slim Span&lbrack;kruskal&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq461dj8.html">HTML 学习笔记 CSS样式（外边框 外边框合并）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jop1lq.html">第一零二天上课  PHP TP框架 引入文件路径问题和调用验证码的方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyeozg9.html">逻辑运算符&mdash;&mdash;逻辑与&amp;amp&semi;&amp;amp&semi;、逻辑或&vert;&vert;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7meonjq.html">Qt中QObject中的parent参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zpxk59.html">How Tomcat Works（十四）补充</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydrmgmq.html">Winform webBrowser 不跳转网页</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd576dq.html">Hibernate HQL查询的参数绑定</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xzox08.html">div中加入iframe，可以实现Ajax的功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0re0eq.html">PHP学习笔记（八）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z1gz29.html">html进阶css（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdeeke8.html">MySQL validate&lowbar;password 插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kop769.html">springboot集成mybatisplus</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eydvgm9.html">Visual studio 编辑combobox程序卡死的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw7dkd8.html">composer修改成国内镜像</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjylml9.html">【UML】NO&period;49&period;EBook&period;5&period;UML&period;1&period;009-【UML 大战需求分析】- 包图（Package Diagram）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2ekwj8.html">C&num; Winform程序以及窗体运行的唯一性汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kovz3rq.html">基于AspectJ的注解方式进行AOP开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/902po34q.html">dwr 框架 ，实现 ajax 的java 框架</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mevox0q.html">New Windows 10 SDK - Toast Notification</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m07em8.html">nginx location匹配顺序及CI框架的nginx配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1p56jq.html">二分查找&lpar;Java实现&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me6nk6q.html">struts2基于注解配置action</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkjkjj8.html">Asp&period;Net Core 2&period;0 项目实战（9） 日志记录，基于Nlog或Microsoft&period;Extensions&period;Logging的实现及调用实例</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z5zve9.html">SpringBoot中MongoDB注解概念及使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljdj619.html">SpringBoot 自定义Banner</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yrw4n8.html">linux --&amp;gt&semi; 进程和线程</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yrpxr8.html">RxJS -- Subscription</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkj2mj8.html">KVM之十：虚拟机在线添加网卡</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
